<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Тестовое задание: Класс DataServer</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Тестовое задание
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Создано системой Doxygen 1.8.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Титульная&#160;страница</span></a></li>
      <li class="current"><a href="annotated.html"><span>Классы</span></a></li>
      <li><a href="files.html"><span>Файлы</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Классы</span></a></li>
      <li><a href="classes.html"><span>Алфавитный&#160;указатель&#160;классов</span></a></li>
      <li><a href="functions.html"><span>Члены&#160;классов</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Классы</a> &#124;
<a href="#pub-types">Открытые типы</a> &#124;
<a href="#pub-methods">Открытые члены</a> &#124;
<a href="class_data_server-members.html">Полный список членов класса</a>  </div>
  <div class="headertitle">
<div class="title">Класс DataServer</div>  </div>
</div><!--header-->
<div class="contents">

<p>Класс описания работы сервера для хранения данных  
 <a href="class_data_server.html#details">Подробнее...</a></p>

<p><code>#include &lt;<a class="el" href="data__server_8h_source.html">data_server.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Открытые типы</h2></td></tr>
<tr class="memitem:a224fa4f36c85fcbce3df48f4c2aaeb8d"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">errs</a> { <br />
&#160;&#160;<a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498">SUCCESS</a>, 
<a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da929982c48a3240f33eb4fdefcb14abe2">ERR_ALREADY_INITIALIZED</a> = -1, 
<a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da2be97d8b1e7116bd395eb51fb89c8a36">ERR_BLOCK_ID_EXIST</a> = -2, 
<a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8da13289cf9a5cdda04a784ee47529e807f">ERR_BLOCK_DATA_EXIST</a> = -3, 
<br />
&#160;&#160;<a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8daa136f54a5c96b4c0be75afd1532cd983">ERR_BLOCK_ID_NOT_EXIST</a> = -4
<br />
 }</td></tr>
<tr class="memdesc:a224fa4f36c85fcbce3df48f4c2aaeb8d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Набор ошибок - результатов выполнения операций  <a href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">Подробнее...</a><br /></td></tr>
<tr class="separator:a224fa4f36c85fcbce3df48f4c2aaeb8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Открытые члены</h2></td></tr>
<tr class="memitem:acf71809c4ac2e7eb13d1ad0c6c139b15"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#acf71809c4ac2e7eb13d1ad0c6c139b15">DataServer</a> ()</td></tr>
<tr class="separator:acf71809c4ac2e7eb13d1ad0c6c139b15"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4f08bb5349b6b9e021da97db65f1928"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#ab4f08bb5349b6b9e021da97db65f1928">~DataServer</a> ()</td></tr>
<tr class="separator:ab4f08bb5349b6b9e021da97db65f1928"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a140ede2da0a4361869c65da205dd1b97"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#a140ede2da0a4361869c65da205dd1b97">init</a> (uint64_t blockSize, uint32_t blobSize)</td></tr>
<tr class="separator:a140ede2da0a4361869c65da205dd1b97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a204be5b40179d75ac26ac216a51f8e37"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#a204be5b40179d75ac26ac216a51f8e37">putBlock</a> (uint64_t blockId, const char *blockData)</td></tr>
<tr class="separator:a204be5b40179d75ac26ac216a51f8e37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab9d8b7d8c058091752d7f42ebb1b1ed"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_data_server.html#aab9d8b7d8c058091752d7f42ebb1b1ed">getBlock</a> (uint64_t blockId, char *blockData)</td></tr>
<tr class="separator:aab9d8b7d8c058091752d7f42ebb1b1ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Подробное описание</h2>
<div class="textblock"><p>Класс описания работы сервера для хранения данных </p>
<p>Класс, определяющий логику добавления и извлечения блоков из хранилища.</p>
<p>Блоки данных объединяются в логические блобы, которые физически хранятся в файлах на диске. Для обеспечения дедупликации данных на сервере хранятся две таблицы _tableIndex _tableHash. В первой ключ - индекс блока, во второй - хэш данных блока. _tableIndex позволяет производить быстрый поиск средствами C++ по индексу, _tableHash - по хэшу-функции данных блока. Во всех таблицах ключ уникален. Если данные уже присутствуют в хранилище, но индекса добавления в хранилище нет, то в ::_tableIndex добавляется новый индекс с описанием присутствующего в хранилище блока. </p>
</div><h2 class="groupheader">Перечисления</h2>
<a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_data_server.html#a224fa4f36c85fcbce3df48f4c2aaeb8d">DataServer::errs</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Набор ошибок - результатов выполнения операций </p>
<table class="fieldtable">
<tr><th colspan="2">Элементы перечислений</th></tr><tr><td class="fieldname"><a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8da593852054b513cea873bd1e73c593498"></a>SUCCESS&#160;</td><td class="fielddoc">
<p>успешное выполнение </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8da929982c48a3240f33eb4fdefcb14abe2"></a>ERR_ALREADY_INITIALIZED&#160;</td><td class="fielddoc">
<p>хранилище уже инициализировано </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8da2be97d8b1e7116bd395eb51fb89c8a36"></a>ERR_BLOCK_ID_EXIST&#160;</td><td class="fielddoc">
<p>блок с таким ID уже существует </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8da13289cf9a5cdda04a784ee47529e807f"></a>ERR_BLOCK_DATA_EXIST&#160;</td><td class="fielddoc">
<p>блок с такими данными уже существует </p>
</td></tr>
<tr><td class="fieldname"><a class="anchor" id="a224fa4f36c85fcbce3df48f4c2aaeb8daa136f54a5c96b4c0be75afd1532cd983"></a>ERR_BLOCK_ID_NOT_EXIST&#160;</td><td class="fielddoc">
<p>блок с таким ID не найден </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Конструктор(ы)</h2>
<a class="anchor" id="acf71809c4ac2e7eb13d1ad0c6c139b15"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DataServer::DataServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Конструктор класса </p>

</div>
</div>
<a class="anchor" id="ab4f08bb5349b6b9e021da97db65f1928"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">DataServer::~DataServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Деструктор класса </p>

</div>
</div>
<h2 class="groupheader">Методы</h2>
<a class="anchor" id="aab9d8b7d8c058091752d7f42ebb1b1ed"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataServer::getBlock </td>
          <td>(</td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>blockId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>blockData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Извлекает блок данных из хранилища</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockId</td><td>идентификатор блока </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blockData</td><td>указатель на блок данных</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<a class="anchor" id="a140ede2da0a4361869c65da205dd1b97"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataServer::init </td>
          <td>(</td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>blockSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>blobSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Инициалирует объект - указывает размер блоба и блока</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockSize</td><td>размер блока </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blobSize</td><td>размеб блоба</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<a class="anchor" id="a204be5b40179d75ac26ac216a51f8e37"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int DataServer::putBlock </td>
          <td>(</td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>blockId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>blockData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Добавляет блок данных в хранилище</p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockId</td><td>идентификатор блока </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blockData</td><td>указатель на блок данных</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>результат выполнения операции (не ноль - ошибка) </dd></dl>

</div>
</div>
<hr/>Объявления и описания членов классов находятся в файлах:<ul>
<li><a class="el" href="data__server_8h_source.html">data_server.h</a></li>
<li>data_server.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Документация по Тестовое задание. Последние изменения: Вт 13 Сен 2016 20:23:58. Создано системой &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
